
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "mpsl.y"

/*

    MPSL - Minimum Profit Scripting Language
    Copyright (C) 2003/2009 Angel Ortega <angel@triptico.com>

    mpsl.y - Minimum Profit Scripting Language YACC parser

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    http://www.triptico.com

*/

#include <stdio.h>
#include <string.h>
#include <wchar.h>
#include "mpdm.h"
#include "mpsl.h"

/*******************
	Data
********************/

/* the bytecode being generated */
static mpdm_t mpsl_bytecode = NULL;

/* pointer to source code being compiled */
extern wchar_t * mpsl_next_char;

/* pointer to file being compiled */
extern FILE * mpsl_file;

/* line number */
extern int mpsl_line;

/* compiled filename (for errors) */
static char * mpsl_filename = NULL;

/* cached value MPSL.OPCODE */
extern mpdm_t mpsl_opcodes;

/* cached value MPSL.LC */
extern mpdm_t mpsl_lc;

/*******************
	Code
********************/

int yylex(void);
void yyerror(char * s);

#define INS0(o)			mpsl_mkins(o, 0, NULL, NULL, NULL)
#define INS1(o,a1)		mpsl_mkins(o, 1, a1, NULL, NULL)
#define INS2(o,a1,a2)		mpsl_mkins(o, 2, a1, a2, NULL)
#define INS3(o,a1,a2,a3)	mpsl_mkins(o, 3, a1, a2, a3)

static mpdm_t mpsl_x(mpdm_t a1, mpdm_t a2, int sf)
/* creates an executable value with the MPSL executor as the first
   argument and a compiled stream as the second */
{
	return MPDM_X2(mpsl_exec_p,
		mpsl_mkins(sf ? L"SUBFRAME" : L"BLKFRAME",
			a2 == NULL ? 1 : 2, a1, a2, NULL));
}


static void compiler_warning(char * str)
{
	fprintf(stderr, "WARNING: %s.\n", str);
}




/* Line 189 of yacc.c  */
#line 161 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NULLV = 258,
     INTEGER = 259,
     REAL = 260,
     STRING = 261,
     SYMBOL = 262,
     LITERAL = 263,
     WHILE = 264,
     IF = 265,
     SUB = 266,
     FOREACH = 267,
     LOCAL = 268,
     BREAK = 269,
     RETURN = 270,
     IFI = 271,
     ELSE = 272,
     BOOLOR = 273,
     BOOLAND = 274,
     IMOD = 275,
     IDIV = 276,
     IMUL = 277,
     ISUB = 278,
     IADD = 279,
     DEC = 280,
     INC = 281,
     RANGE = 282,
     HASHPAIR = 283,
     NUMLE = 284,
     NUMGE = 285,
     NUMNE = 286,
     STRNE = 287,
     NUMEQ = 288,
     STREQ = 289,
     STRCAT = 290,
     BITAND = 291,
     BITXOR = 292,
     BITOR = 293,
     MOD = 294,
     UMINUS = 295
   };
#endif
/* Tokens.  */
#define NULLV 258
#define INTEGER 259
#define REAL 260
#define STRING 261
#define SYMBOL 262
#define LITERAL 263
#define WHILE 264
#define IF 265
#define SUB 266
#define FOREACH 267
#define LOCAL 268
#define BREAK 269
#define RETURN 270
#define IFI 271
#define ELSE 272
#define BOOLOR 273
#define BOOLAND 274
#define IMOD 275
#define IDIV 276
#define IMUL 277
#define ISUB 278
#define IADD 279
#define DEC 280
#define INC 281
#define RANGE 282
#define HASHPAIR 283
#define NUMLE 284
#define NUMGE 285
#define NUMNE 286
#define STRNE 287
#define NUMEQ 288
#define STREQ 289
#define STRCAT 290
#define BITAND 291
#define BITXOR 292
#define BITOR 293
#define MOD 294
#define UMINUS 295




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 88 "mpsl.y"

	mpdm_t v;	/* a simple value */
	mpdm_t ins;	/* an 'instruction': [ opcode, args ] */



/* Line 214 of yacc.c  */
#line 284 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 296 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1170

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  58
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNRULES -- Number of states.  */
#define YYNSTATES  181

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   295

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    27,     2,     2,     2,     2,     2,     2,
      49,    50,    44,    42,    53,    43,    55,    45,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    48,
      29,    54,    28,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    56,     2,    57,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    51,     2,    52,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    46,    47
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    11,    14,    20,    26,
      34,    40,    48,    57,    65,    74,    78,    82,    88,    91,
      95,    98,   100,   103,   105,   109,   111,   115,   119,   125,
     127,   131,   135,   140,   142,   144,   146,   148,   150,   153,
     157,   161,   165,   169,   173,   177,   181,   185,   188,   191,
     194,   197,   201,   205,   209,   213,   217,   220,   224,   228,
     232,   236,   240,   244,   248,   252,   256,   260,   264,   269,
     277,   281,   284,   288,   294,   297,   301,   305,   310
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      59,     0,    -1,    60,    -1,    60,    62,    -1,    -1,    48,
      -1,    67,    48,    -1,     9,    49,    67,    50,    61,    -1,
      10,    49,    67,    50,    61,    -1,    10,    49,    67,    50,
      61,    17,    61,    -1,    11,    66,    51,    62,    52,    -1,
      11,    66,    49,    50,    51,    62,    52,    -1,    11,    66,
      49,    64,    50,    51,    62,    52,    -1,    12,    49,    66,
      53,    67,    50,    61,    -1,    12,    49,    13,    66,    53,
      67,    50,    61,    -1,    51,    62,    52,    -1,    13,    64,
      48,    -1,    13,     7,    54,    67,    48,    -1,    14,    48,
      -1,    15,    67,    48,    -1,    15,    48,    -1,    61,    -1,
      62,    61,    -1,    67,    -1,    63,    53,    67,    -1,     7,
      -1,    64,    53,     7,    -1,    67,    31,    67,    -1,    65,
      53,    67,    31,    67,    -1,     7,    -1,    66,    55,     4,
      -1,    66,    55,     7,    -1,    66,    56,    67,    57,    -1,
       4,    -1,     6,    -1,     5,    -1,    66,    -1,     3,    -1,
      43,    67,    -1,    67,    42,    67,    -1,    67,    43,    67,
      -1,    67,    44,    67,    -1,    67,    45,    67,    -1,    67,
      46,    67,    -1,    67,    39,    67,    -1,    67,    41,    67,
      -1,    67,    40,    67,    -1,    26,    66,    -1,    25,    66,
      -1,    66,    26,    -1,    66,    25,    -1,    66,    24,    67,
      -1,    66,    23,    67,    -1,    66,    22,    67,    -1,    66,
      21,    67,    -1,    66,    20,    67,    -1,    27,    67,    -1,
      67,    29,    67,    -1,    67,    28,    67,    -1,    67,    32,
      67,    -1,    67,    33,    67,    -1,    67,    36,    67,    -1,
      67,    34,    67,    -1,    67,    38,    67,    -1,    67,    37,
      67,    -1,    67,    35,    67,    -1,    67,    19,    67,    -1,
      67,    18,    67,    -1,    11,    51,    62,    52,    -1,    11,
      49,    64,    50,    51,    62,    52,    -1,    49,    67,    50,
      -1,    56,    57,    -1,    56,    63,    57,    -1,    56,    67,
      30,    67,    57,    -1,    51,    52,    -1,    51,    65,    52,
      -1,    66,    49,    50,    -1,    66,    49,    63,    50,    -1,
      66,    54,    67,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   113,   113,   117,   120,   124,   128,   133,   138,   143,
     149,   158,   168,   177,   189,   201,   207,   211,   222,   226,
     230,   237,   238,   245,   248,   256,   260,   268,   271,   280,
     284,   289,   294,   301,   305,   309,   313,   317,   322,   328,
     329,   330,   331,   332,   335,   336,   337,   340,   347,   356,
     366,   378,   384,   390,   396,   402,   409,   413,   417,   421,
     425,   429,   433,   439,   443,   447,   453,   457,   462,   467,
     473,   478,   482,   486,   492,   496,   501,   505,   509
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NULLV", "INTEGER", "REAL", "STRING",
  "SYMBOL", "LITERAL", "WHILE", "IF", "SUB", "FOREACH", "LOCAL", "BREAK",
  "RETURN", "IFI", "ELSE", "BOOLOR", "BOOLAND", "IMOD", "IDIV", "IMUL",
  "ISUB", "IADD", "DEC", "INC", "'!'", "'>'", "'<'", "RANGE", "HASHPAIR",
  "NUMLE", "NUMGE", "NUMNE", "STRNE", "NUMEQ", "STREQ", "STRCAT", "BITAND",
  "BITXOR", "BITOR", "'+'", "'-'", "'*'", "'/'", "MOD", "UMINUS", "';'",
  "'('", "')'", "'{'", "'}'", "','", "'='", "'.'", "'['", "']'", "$accept",
  "program", "function", "stmt", "stmt_list", "list", "sym_list", "hash",
  "compsym", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,    33,    62,    60,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,    43,    45,    42,    47,   294,   295,    59,    40,
      41,   123,   125,    44,    61,    46,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    58,    59,    60,    60,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    62,    62,    63,    63,    64,    64,    65,    65,    66,
      66,    66,    66,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     2,     5,     5,     7,
       5,     7,     8,     7,     8,     3,     3,     5,     2,     3,
       2,     1,     2,     1,     3,     1,     3,     3,     5,     1,
       3,     3,     4,     1,     1,     1,     1,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     7,
       3,     2,     3,     5,     2,     3,     3,     4,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     2,     1,    37,    33,    35,    34,    29,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     0,     0,     0,    21,     3,    36,     0,     0,     0,
       0,     0,     0,     0,    25,     0,    18,     0,    20,     0,
       0,    48,    47,    56,    38,     0,    74,     0,     0,     0,
      71,     0,    23,    22,     0,     0,     0,     0,     0,    50,
      49,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     0,    25,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,    19,    70,
      15,    75,     0,     0,     0,    72,     0,    55,    54,    53,
      52,    51,    76,     0,    23,    78,    30,    31,     0,    67,
      66,    58,    57,    59,    60,    62,    65,    61,    64,    63,
      44,    46,    45,    39,    40,    41,    42,    43,     0,     0,
       0,    68,     0,     0,     0,     0,     0,     0,    26,     0,
      27,    24,     0,    77,    32,     7,     8,     0,     0,     0,
      10,     0,     0,    17,     0,    73,     0,     0,     0,     0,
       0,     0,    28,     9,    69,    11,     0,     0,    13,    12,
      14
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    24,    25,    51,    35,    48,    26,    27
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -40
static const yytype_int16 yypact[] =
{
     -40,     2,   554,   -40,   -40,   -40,   -40,   -40,   -40,   -39,
      17,    16,    49,    52,   -24,   581,    66,    66,   663,   663,
     -40,   663,   176,     1,   -40,   554,    80,   925,   663,   663,
     108,   554,     0,    -4,    90,    59,   -40,    96,   -40,   608,
     956,    -8,    -8,  1124,   -40,   749,   -40,   230,    97,   894,
     -40,   -32,  1018,   -40,   663,   663,   663,   663,   663,   -40,
     -40,   636,   663,    27,   663,   663,   663,   663,   663,   663,
     663,   663,   663,   663,   663,   663,   663,   663,   663,   663,
     663,   663,   663,   663,   -40,   778,   807,   -40,   -12,   284,
       4,   554,    66,    77,   663,   -40,   124,  1047,   -40,   -40,
     -40,   -40,   663,   663,   663,   -40,   663,  1124,  1124,  1124,
    1124,  1124,   -40,    10,  1105,  1105,   -40,   -40,   689,  1124,
    1124,   -26,   -26,   -26,   -26,   -26,   -26,   -26,   -26,   -26,
      82,   111,   111,    65,    65,   -40,   -40,   -40,   554,   554,
      87,   -40,   107,    24,   338,    84,   663,   987,   -40,  1076,
    1105,  1105,   719,   -40,   -40,   -40,   131,   554,   554,   110,
     -40,   663,   836,   -40,   663,   -40,   554,   392,   446,   554,
     865,   554,  1105,   -40,   -40,   -40,   500,   554,   -40,   -40,
     -40
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -40,   -40,   -40,   -25,     8,    98,   -29,   -40,    29,    14
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      53,    88,     3,     8,     4,     5,     6,     7,     8,    92,
      28,    87,    37,    76,    77,    78,    79,    80,    81,    82,
      83,   104,    53,     8,    36,   105,    16,    17,    18,    40,
      47,   116,    43,    44,   117,    45,    49,    52,   140,    89,
      32,    96,    85,    86,    19,    41,    42,    63,    64,    90,
      21,    91,    39,    97,   142,    63,    64,    23,    50,    34,
     153,   143,    93,   104,    53,    30,    29,    31,   107,   108,
     109,   110,   111,     8,   159,   114,   115,    96,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    33,   144,
      54,    55,    56,    57,    58,    59,    60,    95,   147,    81,
      82,    83,    96,   155,   156,    87,   149,   150,   151,    53,
     152,   145,    77,    78,    79,    80,    81,    82,    83,    61,
     146,   148,    63,    64,    62,    63,    64,   161,   157,    63,
      64,   173,    53,    53,    94,    30,   178,    31,   166,   101,
     102,    53,   180,    79,    80,    81,    82,    83,   158,   113,
     162,   169,     0,     0,     0,   167,   168,     0,     0,     0,
       0,     0,     0,     0,     0,   170,     0,   176,   172,     4,
       5,     6,     7,     8,     0,     9,    10,    11,    12,    13,
      14,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    19,
       0,     0,     0,     0,    20,    21,     0,    22,    46,     0,
       0,     0,    23,     4,     5,     6,     7,     8,     0,     9,
      10,    11,    12,    13,    14,    15,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,    20,    21,
       0,    22,   100,     0,     0,     0,    23,     4,     5,     6,
       7,     8,     0,     9,    10,    11,    12,    13,    14,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,    20,    21,     0,    22,   141,     0,     0,     0,
      23,     4,     5,     6,     7,     8,     0,     9,    10,    11,
      12,    13,    14,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    19,     0,     0,     0,     0,    20,    21,     0,    22,
     160,     0,     0,     0,    23,     4,     5,     6,     7,     8,
       0,     9,    10,    11,    12,    13,    14,    15,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,    18,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    19,     0,     0,     0,     0,
      20,    21,     0,    22,   174,     0,     0,     0,    23,     4,
       5,     6,     7,     8,     0,     9,    10,    11,    12,    13,
      14,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    19,
       0,     0,     0,     0,    20,    21,     0,    22,   175,     0,
       0,     0,    23,     4,     5,     6,     7,     8,     0,     9,
      10,    11,    12,    13,    14,    15,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,    20,    21,
       0,    22,   179,     0,     0,     0,    23,     4,     5,     6,
       7,     8,     0,     9,    10,    11,    12,    13,    14,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,    18,     0,     0,     4,     5,     6,     7,     8,     0,
       0,     0,    37,     0,     0,     0,     0,    19,     0,     0,
       0,     0,    20,    21,     0,    22,    16,    17,    18,     0,
      23,     4,     5,     6,     7,     8,     0,     0,     0,    37,
       0,     0,     0,     0,    19,     0,     0,     0,     0,    38,
      21,     0,    39,    16,    17,    18,     0,    23,     0,     4,
       5,     6,     7,     8,     0,     0,     0,    37,     0,     0,
       0,    19,     0,     0,     0,     0,     0,    21,     0,    39,
      46,    16,    17,    18,    23,     0,     4,     5,     6,     7,
       8,     0,     0,     0,    37,     0,     0,     0,     0,    19,
       0,     0,     0,     0,     0,    21,   112,    39,    16,    17,
      18,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    19,    65,    66,     0,
       0,     0,    21,     0,    39,     0,     0,    67,    68,    23,
       0,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     0,    65,    66,     0,
       0,     0,     0,     0,     0,     0,   154,    67,    68,     0,
       0,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     0,    65,    66,     0,
       0,     0,     0,     0,     0,     0,   165,    67,    68,     0,
       0,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    65,    66,     0,    99,
       0,     0,     0,     0,     0,     0,    67,    68,     0,     0,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    65,    66,     0,   138,     0,
       0,     0,     0,     0,     0,    67,    68,     0,     0,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    65,    66,     0,   139,     0,     0,
       0,     0,     0,     0,    67,    68,     0,     0,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    65,    66,     0,   171,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    65,    66,     0,   177,     0,     0,     0,     0,
       0,     0,    67,    68,     0,   103,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,     0,    84,    65,    66,     0,     0,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,     0,    84,    65,    66,     0,     0,     0,     0,
       0,     0,     0,     0,    67,    68,     0,     0,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,     0,    98,    65,    66,     0,     0,     0,
       0,     0,     0,     0,     0,    67,    68,     0,     0,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,     0,   163,    65,    66,     0,     0,
       0,     0,     0,     0,     0,     0,    67,    68,   106,     0,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    65,    66,     0,     0,     0,
       0,     0,     0,     0,     0,    67,    68,     0,   103,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    65,    66,     0,     0,     0,     0,
       0,     0,     0,     0,    67,    68,     0,   164,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    65,    66,     0,     0,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    67,    68,     0,     0,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83
};

static const yytype_int16 yycheck[] =
{
      25,    30,     0,     7,     3,     4,     5,     6,     7,    13,
      49,     7,    11,    39,    40,    41,    42,    43,    44,    45,
      46,    53,    47,     7,    48,    57,    25,    26,    27,    15,
      22,     4,    18,    19,     7,    21,    22,    23,    50,    31,
      11,    53,    28,    29,    43,    16,    17,    55,    56,    49,
      49,    51,    51,    39,    50,    55,    56,    56,    57,     7,
      50,    90,    33,    53,    89,    49,    49,    51,    54,    55,
      56,    57,    58,     7,    50,    61,    62,    53,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    49,    91,
      20,    21,    22,    23,    24,    25,    26,    48,    94,    44,
      45,    46,    53,   138,   139,     7,   102,   103,   104,   144,
     106,    92,    40,    41,    42,    43,    44,    45,    46,    49,
      53,     7,    55,    56,    54,    55,    56,    53,    51,    55,
      56,   166,   167,   168,    54,    49,   171,    51,    17,    52,
      53,   176,   177,    42,    43,    44,    45,    46,    51,    61,
     146,    51,    -1,    -1,    -1,   157,   158,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   161,    -1,   169,   164,     3,
       4,     5,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    56,     3,     4,     5,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    56,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      56,     3,     4,     5,     6,     7,    -1,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    56,     3,     4,     5,     6,     7,
      -1,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    56,     3,
       4,     5,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    56,     3,     4,     5,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    56,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      26,    27,    -1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    25,    26,    27,    -1,
      56,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    48,
      49,    -1,    51,    25,    26,    27,    -1,    56,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    -1,    51,
      52,    25,    26,    27,    56,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    25,    26,
      27,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    18,    19,    -1,
      -1,    -1,    49,    -1,    51,    -1,    -1,    28,    29,    56,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    28,    29,    -1,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    28,    29,    -1,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    18,    19,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    -1,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    18,    19,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    -1,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    18,    19,    -1,    50,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    -1,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    18,    19,    -1,    50,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    18,    19,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    -1,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    -1,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    28,    29,    -1,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    59,    60,     0,     3,     4,     5,     6,     7,     9,
      10,    11,    12,    13,    14,    15,    25,    26,    27,    43,
      48,    49,    51,    56,    61,    62,    66,    67,    49,    49,
      49,    51,    66,    49,     7,    64,    48,    11,    48,    51,
      67,    66,    66,    67,    67,    67,    52,    62,    65,    67,
      57,    63,    67,    61,    20,    21,    22,    23,    24,    25,
      26,    49,    54,    55,    56,    18,    19,    28,    29,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    48,    67,    67,     7,    64,    62,
      49,    51,    13,    66,    54,    48,    53,    67,    48,    50,
      52,    52,    53,    31,    53,    57,    30,    67,    67,    67,
      67,    67,    50,    63,    67,    67,     4,     7,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    50,    50,
      50,    52,    50,    64,    62,    66,    53,    67,     7,    67,
      67,    67,    67,    50,    57,    61,    61,    51,    51,    50,
      52,    53,    67,    48,    31,    57,    17,    62,    62,    51,
      67,    50,    67,    61,    52,    52,    62,    50,    61,    52,
      61
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 113 "mpsl.y"
    { ; }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 117 "mpsl.y"
    {
					mpsl_bytecode = (yyvsp[(2) - (2)].ins);
				}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 124 "mpsl.y"
    {
					/* null instruction */
					(yyval.ins) = INS0(L"MULTI");
				}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 128 "mpsl.y"
    {
					/* expression, as is */
					(yyval.ins) = (yyvsp[(1) - (2)].ins);
				}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 134 "mpsl.y"
    {
					/* while loop */
					(yyval.ins) = INS2(L"WHILE", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins));
				}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 139 "mpsl.y"
    {
					/* if - then construction */
					(yyval.ins) = INS2(L"IF", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins));
				}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 144 "mpsl.y"
    {
					/* if - then - else construction */
					(yyval.ins) = INS3(L"IF", (yyvsp[(3) - (7)].ins), (yyvsp[(5) - (7)].ins), (yyvsp[(7) - (7)].ins));
				}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 150 "mpsl.y"
    {
					/* subroutine definition,
					   without arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (5)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(4) - (5)].ins), NULL, 1)));
				}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 159 "mpsl.y"
    {
					/* subroutine definition,
					   without arguments (second
					   syntax, including parens) */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (7)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(6) - (7)].ins), NULL, 1)));
				}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 169 "mpsl.y"
    {
					/* subroutine definition,
					   with arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (8)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(7) - (8)].ins), (yyvsp[(4) - (8)].ins), 1)));
				}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 178 "mpsl.y"
    {
					/* foreach construction */
					/* a block frame is created, the iterator
					   created as local, and the foreach executed */
					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[(3) - (7)].ins)),
							INS3(L"FOREACH", (yyvsp[(3) - (7)].ins), (yyvsp[(5) - (7)].ins), (yyvsp[(7) - (7)].ins))
						)
					);
				}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 190 "mpsl.y"
    {
					compiler_warning("useless use of local in foreach loop");

					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[(4) - (8)].ins)),
							INS3(L"FOREACH", (yyvsp[(4) - (8)].ins), (yyvsp[(6) - (8)].ins), (yyvsp[(8) - (8)].ins))
						)
					);
				}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 201 "mpsl.y"
    {
					/* block of instructions,
					   with local symbol table */
					(yyval.ins) = INS1(L"BLKFRAME", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 207 "mpsl.y"
    {
					/* local symbol creation */
					(yyval.ins) = INS1(L"LOCAL", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 212 "mpsl.y"
    {
					/* contraction; local symbol
					   creation and assignation */
					(yyval.ins) = INS2(L"MULTI",
						INS1(L"LOCAL",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v))),
						INS2(L"ASSIGN",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v)),(yyvsp[(4) - (5)].ins))
						);
				}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 222 "mpsl.y"
    {
					/* break (exit from loop) */
					(yyval.ins) = INS0(L"BREAK");
				}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 226 "mpsl.y"
    {
					/* return from subroutine */
					(yyval.ins) = INS1(L"RETURN", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 230 "mpsl.y"
    {
					/* return from subroutine (void) */
					(yyval.ins) = INS0(L"RETURN");
				}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 237 "mpsl.y"
    { (yyval.ins) = (yyvsp[(1) - (1)].ins); }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 238 "mpsl.y"
    {
					/* sequence of instructions */
					(yyval.ins) = INS2(L"MULTI", (yyvsp[(1) - (2)].ins), (yyvsp[(2) - (2)].ins));
				}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 245 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST", (yyvsp[(1) - (1)].ins));
				}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 248 "mpsl.y"
    {
					/* build list from list of
					   instructions */
					(yyval.ins) = INS2(L"LIST", (yyvsp[(3) - (3)].ins), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 256 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[(1) - (1)].v)));
				}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 260 "mpsl.y"
    {
					/* comma-separated list of symbols */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 268 "mpsl.y"
    {
					(yyval.ins) = INS2(L"HASH", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 272 "mpsl.y"
    {
					/* build hash from list of
					   instructions */
					(yyval.ins) = INS3(L"HASH", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins), (yyvsp[(1) - (5)].ins));
				}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 280 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[(1) - (1)].v)));
				}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 284 "mpsl.y"
    {
					/* a.5 compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 289 "mpsl.y"
    {
					/* a.b compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 294 "mpsl.y"
    {
					/* a["b"] or a[5] compound symbol */
					(yyval.ins) = INS2(L"LIST", (yyvsp[(3) - (4)].ins), (yyvsp[(1) - (4)].ins));
				}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 301 "mpsl.y"
    {
					/* literal integer */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 305 "mpsl.y"
    {
					/* literal string */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 309 "mpsl.y"
    {
					/* literal real number */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 313 "mpsl.y"
    {
					/* compound symbol */
					(yyval.ins) = INS1(L"SYMVAL", (yyvsp[(1) - (1)].ins));
				}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 317 "mpsl.y"
    {
					/* NULL value */
					(yyval.ins) = INS1(L"LITERAL", NULL);
				}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 322 "mpsl.y"
    {
					/* unary minus */
					(yyval.ins) = INS1(L"UMINUS", (yyvsp[(2) - (2)].ins));
				}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 328 "mpsl.y"
    { (yyval.ins) = INS2(L"ADD", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 329 "mpsl.y"
    { (yyval.ins) = INS2(L"SUB", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 330 "mpsl.y"
    { (yyval.ins) = INS2(L"MUL", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 331 "mpsl.y"
    { (yyval.ins) = INS2(L"DIV", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 332 "mpsl.y"
    { (yyval.ins) = INS2(L"MOD", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 335 "mpsl.y"
    { (yyval.ins) = INS2(L"BITAND", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 336 "mpsl.y"
    { (yyval.ins) = INS2(L"BITOR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 337 "mpsl.y"
    { (yyval.ins) = INS2(L"BITXOR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 340 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (2)].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[(2) - (2)].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 347 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (2)].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[(2) - (2)].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 356 "mpsl.y"
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
					INS2(L"ASSIGN", (yyvsp[(1) - (2)].ins),
						INS2(L"ADD",
							INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 366 "mpsl.y"
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
					INS2(L"ASSIGN", (yyvsp[(1) - (2)].ins),
						INS2(L"SUB",
							INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 378 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 384 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 390 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"MUL",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 396 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"DIV",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 402 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"MOD",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 409 "mpsl.y"
    {
					/* boolean not */
					(yyval.ins) = INS1(L"NOT", (yyvsp[(2) - (2)].ins));
				}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 413 "mpsl.y"
    {
					/* bool less than */
					(yyval.ins) = INS2(L"NUMLT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 417 "mpsl.y"
    {
					/* bool greater than */
					(yyval.ins) = INS2(L"NUMGT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 421 "mpsl.y"
    {
					/* bool less or equal than */
					(yyval.ins) = INS2(L"NUMLE", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 425 "mpsl.y"
    {
					/* bool greater or equal than */
					(yyval.ins) = INS2(L"NUMGE", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 429 "mpsl.y"
    {
					/* bool numeric equal */
					(yyval.ins) = INS2(L"NUMEQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 433 "mpsl.y"
    {
					/* bool numeric non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"NUMEQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)));
				}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 439 "mpsl.y"
    {
					/* string concatenation */
					(yyval.ins) = INS2(L"STRCAT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 443 "mpsl.y"
    {
					/* bool string equal */
					(yyval.ins) = INS2(L"STREQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 447 "mpsl.y"
    {
					/* bool string non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"STREQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)));
				}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 453 "mpsl.y"
    {
					/* boolean and */
					(yyval.ins) = INS2(L"AND", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 457 "mpsl.y"
    {
					/* boolean or */
					(yyval.ins) = INS2(L"OR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 462 "mpsl.y"
    {
					/* anonymous subroutine (without args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[(3) - (4)].ins), NULL, 0));
				}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 468 "mpsl.y"
    {
					/* anonymous subroutine (with args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[(6) - (7)].ins), (yyvsp[(3) - (7)].ins), 0));
				}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 473 "mpsl.y"
    {
					/* parenthesized expression */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 478 "mpsl.y"
    {
					/* empty list */
					(yyval.ins) = INS1(L"LITERAL", MPDM_A(0));
				}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 482 "mpsl.y"
    {
					/* non-empty list */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 487 "mpsl.y"
    {
					/* build range from expressions */
					(yyval.ins) = INS2(L"RANGE", (yyvsp[(2) - (5)].ins), (yyvsp[(4) - (5)].ins));
				}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 492 "mpsl.y"
    {
					/* empty hash */
					(yyval.ins) = INS1(L"LITERAL", MPDM_H(0));
				}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 496 "mpsl.y"
    {
					/* non-empty hash */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 501 "mpsl.y"
    {
					/* function call (without args) */
					(yyval.ins) = INS1(L"EXECSYM", (yyvsp[(1) - (3)].ins));
				}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 505 "mpsl.y"
    {
					/* function call (with args) */
					(yyval.ins) = INS2(L"EXECSYM", (yyvsp[(1) - (4)].ins), (yyvsp[(3) - (4)].ins));
				}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 509 "mpsl.y"
    {
					/* simple assignation */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;



/* Line 1455 of yacc.c  */
#line 2628 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 516 "mpsl.y"


void yyerror(char * s)
{
	char tmp[1024];

	snprintf(tmp, sizeof(tmp), "%s in %s, line %d",
		s, mpsl_filename, mpsl_line + 1);

	mpsl_error(MPDM_MBS(tmp));
}


static FILE * inc_fopen(const char * filename, mpdm_t inc)
/* loads filename, searching in INC if not directly accesible */
{
	FILE * f = NULL;
	char tmp[1024];
	int n;

	/* loop through INC, prepending each path
	   to the filename */
	for (n = 0; n < mpdm_size(inc); n++) {
		mpdm_t v = mpdm_aget(inc, n);

		v = MPDM_2MBS(v->data);
		snprintf(tmp, sizeof(tmp), "%s/%s",
			(char *)v->data, filename);

		if ((f = fopen(tmp, "r")) != NULL)
			break;
	}

	return f;
}


static mpdm_t do_parse(const char * filename, wchar_t * code, FILE * file)
/* calls yyparse() after doing some initialisations, and returns
   the compiled code as an executable value */
{
	mpdm_t v;
	mpdm_t x = NULL;

	/* first line */
	mpsl_line = 0;

	/* reset last bytecode */
	mpsl_bytecode = NULL;

	/* set globals */
	mpsl_next_char = code;
	mpsl_file = file;

	if (mpsl_filename != NULL)
		free(mpsl_filename);

	mpsl_filename = strdup(filename);

	/* cache some values */
	v = mpdm_hget_s(mpdm_root(), L"MPSL");
	mpsl_opcodes = mpdm_hget_s(v, L"OPCODE");
	mpsl_lc = mpdm_hget_s(v, L"LC");

	/* compile! */
	if (yyparse() == 0 && mpsl_bytecode != NULL)
		x = mpsl_x(mpsl_bytecode, NULL, 1);

	/* clean back cached values */
	mpsl_opcodes = NULL;
	mpsl_lc = NULL;

	return x;
}


/**
 * mpsl_compile - Compiles a string of MPSL code.
 * @code: A value containing a string of MPSL code
 *
 * Compiles a string of MPSL code and returns an mpdm value executable
 * by mpdm_exec(). If there is a syntax (or other type) error, NULL
 * is returned instead.
 */
mpdm_t mpsl_compile(mpdm_t code)
{
	mpdm_t x = NULL;

	mpdm_ref(code);
	x = do_parse("<INLINE>", (wchar_t *) code->data, NULL);
	mpdm_unref(code);

	return x;
}


/**
 * mpsl_compile_file - Compiles a file of MPSL code.
 * @file: File stream or file name.
 *
 * Compiles a source file of MPSL code and returns an mpdm value
 * executable by mpdm_exec(). If @file is an MPSL file descriptor,
 * it's read as is and compiled; otherwise, it's assumed to be a
 * file name, that will be searched for in any of the paths defined
 * in the INC MPSL global array (take note that the current
 * directory is NOT searched by default). If the file cannot be found
 * or there is any other error, NULL is returned instead.
 */
mpdm_t mpsl_compile_file(mpdm_t file)
{
	mpdm_t x = NULL;
	FILE * f = NULL;
	const char * filename = NULL;

	if ((f = mpdm_get_filehandle(file)) != NULL) {
		filename = "<FILE>";
	}
	else {
		mpdm_t inc = mpsl_get_symbol(MPDM_LS(L"INC"));

		/* it's a filename; open it */
		file = MPDM_2MBS(file->data);

		filename = file->data;

		if ((f = inc_fopen(filename, inc)) == NULL) {
			char tmp[128];

			snprintf(tmp, sizeof(tmp) - 1,
				"File '%s' not found in INC",
				filename);
			mpsl_error(MPDM_MBS(tmp));

			return (NULL);
		}

		file = MPDM_F(f);
	}

	x = do_parse(filename, NULL, f);

	mpdm_close(file);

	return x;
}


/**
 * mpsl_eval - Evaluates MSPL code.
 * @code: A value containing a string of MPSL code, or executable code
 * @args: optional arguments for @code
 *
 * Evaluates a piece of code. The @code can be a string containing MPSL source
 * code (that will be compiled) or a direct executable value. If the compilation
 * or the execution gives an error, the ERROR variable will be set to a printable
 * value and NULL returned. Otherwise, the exit value from the code is returned
 * and ERROR set to NULL. The abort flag is reset on exit.
 */
mpdm_t mpsl_eval(mpdm_t code, mpdm_t args)
{
	mpdm_t v = NULL;

	/* reset error */
	mpsl_error(NULL);
	mpsl_abort = 0;

	/* if code is not executable, try to compile */
	if (!MPDM_IS_EXEC(code))
		code = mpsl_compile(code);

	/* execute, if possible */
	if (MPDM_IS_EXEC(code))
		v = mpdm_exec(code, args);

	/* reset the abort flag */
	mpsl_abort = 0;

	return v;
}

